//TODO Move all preferences related stuff to a separate preferences module.
// Now spread between here, add.js, and deliciousservice.js.

// These are duplicated in add.js. Change here -> change there, too.
var showOwnTagsKey = 'delicious.showOwnTags';
var showPopRecTagsKey = 'delicious.showPopRecTags';

function findGlobals() {
  if (window.opener && window.opener.globals) return window.opener.globals;
  if (window.opener.opener && window.opener.opener.globals) return window.opener.opener.globals;
  if (window.opener.parent && window.opener.parent.globals) return window.opener.parent.globals;
  return null;
}

function addTab(aUrl) {
	var bTarget;

	if(opener) bTarget = opener.top;
	else bTarget = top;

	if(bTarget) {
		var browser = bTarget.getBrowser();
		var selIndex = null;

		for(var i = 0; i < browser.tabContainer.childNodes.length; i++) {
			var browserDoc = browser.getBrowserAtIndex(i).contentWindow.document;

			if(browserDoc.location.href == "about:blank" && browser.selectedTab.getAttribute('openBy') != "aios") {
				browserDoc.location.href = aUrl;
				browser.selectedTab = browser.tabContainer.childNodes[i];
				browser.selectedTab.setAttribute('openBy', 'aios');
				selIndex = i;
				break;
			}
		}

		if(selIndex == null) {
			browser.selectedTab = browser.addTab(aUrl);
			browser.selectedTab.setAttribute('openBy', 'aios');
		}
	}
	else {
		openDialog("chrome://browser/content/browser.xul", "_blank", "chrome, all, dialog=no", aUrl, null, null);
	}
}

var globals = findGlobals();
if (globals == null) {alert("del.icio.us extension error: preference dialog globals not found.");window.close();}

var gShouldLoginOnAccept;

function onAccept()
{
    nsPreferences.setBoolPref(showOwnTagsKey, document.getElementById("delicious-prefs-own-tags").checked);
    nsPreferences.setBoolPref(showPopRecTagsKey, document.getElementById("delicious-prefs-poprec-tags").checked);
    globals.cookies.managementEnabled = document.getElementById("delicious-prefs-cookie-management").checked;
    
    if (globals.cookies.managementEnabled) {
      globals.cookies.allow();
      if (gShouldLoginOnAccept && globals.userManager.getDefaultUser().getUsername().length > 0) {
        globals.messagingService.setDefaultUserRequest(globals.userManager.getDefaultUser().getUsername());
      }
    } else {
      globals.cookies.disallow();
    }

    return true;
}

function onLoad()
{
    initKeyConfig();
    gShouldLoginOnAccept = (globals.cookies.managementEnabled == false) || (globals.userManager.getDefaultUser().getUsername().length == 0);
    document.getElementById("delicious-prefs-cookie-management").checked = globals.cookies.managementEnabled;
    document.getElementById("delicious-prefs-own-tags").checked = nsPreferences.getBoolPref(showOwnTagsKey, true);
    document.getElementById("delicious-prefs-poprec-tags").checked = nsPreferences.getBoolPref(showPopRecTagsKey, true);

    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    var users = globals.userManager.getUsers();
    var defaultUser = globals.userManager.getDefaultUser();

    if (users.length > 0) {
      for (user in users) {
        var li = accountListbox.appendItem(users[user].getAccountName(), users[user].getUsername());
        var lc = document.createElement('listcell');
        lc.setAttribute("class", "listcell-iconic");
        if (users[user].getUsername() == defaultUser.getUsername()) {
          lc.setAttribute("image", "chrome://mozapps/skin/pref/check.gif");
        }
        li.appendChild(lc);
      }
      accountListbox.selectedIndex = 0;
    }
}

function openAccountPrefsDialog()
{
    var selectedItem = document.getElementById("delicious-prefs-accounts-list").selectedItem;
    window.openDialog("chrome://delicious/content/prefUserDialog.xul", "del.icio.us account prefs", "chrome, modal", {'callback':userPrefsChanged, 'globals':globals, 'user':globals.userManager.getUserByName(selectedItem.value)});
}

function usernameIsInUse(username, addingUser)
{
    if (addingUser && globals.userManager.getUsers().length == 0) {
        return false;
    }
    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    var li = accountListbox.getItemAtIndex(0);
    while (li != null) {
        if (li.value == username && (addingUser || accountListbox.getIndexOfItem(li) != accountListbox.selectedIndex)) {
            alert("Usernames must be unique.\nAccount '"+li.label+"' already uses this username.");
            return true;
        }
        li = accountListbox.getNextItem(li, 1);
    }
    return false;
}

//
// Callback for prefUserDialog.xul's onAccept.
// Arguments:
//   - prefs[0] - new username
//   - prefs[1] - new password
//   - prefs[2] - new account name
//   - myGlobals - globals
// Return true if ok to close prefUserDialog, false otherwise.
//
function userPrefsChanged(prefs, myGlobals)
{
    if (usernameIsInUse(prefs[0], false)) {
        return false;
    }
    var selectedItem = document.getElementById("delicious-prefs-accounts-list").selectedItem;
    var oldUsername = selectedItem.value;
    var oldDefaultUsername = myGlobals.userManager.getDefaultUser().getUsername();
    selectedItem.label = prefs[2];
    selectedItem.value = prefs[0];
    if (prefs[0] == oldUsername) {
        var user = myGlobals.userManager.getUserByName(prefs[0]);
        user.setAccountName(prefs[2]);
        user.setPassword(prefs[1]);
    } else {
        myGlobals.userManager.deleteUser(oldUsername);
        myGlobals.userManager.createUser(prefs[0], prefs[1], prefs[2]);
        if (oldDefaultUsername != myGlobals.userManager.getDefaultUser().getUsername()) {
            markNewDefaultUser(prefs[0], oldDefaultUsername);
        }
    }
    if (oldUsername == oldDefaultUsername) {
      gShouldLoginOnAccept = false;
      globals.messagingService.setDefaultUserRequest(prefs[0]);
    }

    return true;
}

function markNewDefaultUser(newDefaultUsername, oldDefaultUsername)
{
    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    var li = accountListbox.getItemAtIndex(0);
    while (li != null) {
        lc = li.childNodes.item(0);
        if (li.value == newDefaultUsername) {
            lc.setAttribute("image", "chrome://mozapps/skin/pref/check.gif");
        } else if (li.value == oldDefaultUsername) {
            lc.setAttribute("image", "");
        }
        li = accountListbox.getNextItem(li, 1);
    }
}

function setDefaultAccount()
{
    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    var selectedUsername = accountListbox.selectedItem.value;
    var previousDefaultUsername = globals.userManager.getDefaultUser().getUsername();

    gShouldLoginOnAccept = false;
    globals.messagingService.setDefaultUserRequest(selectedUsername);
    if (previousDefaultUsername != selectedUsername) {
        markNewDefaultUser(selectedUsername, previousDefaultUsername);
    }
}

function addAccount()
{
    window.openDialog("chrome://delicious/content/prefUserDialog.xul", "", "chrome, modal", {'callback':accountInfoEntered, 'globals':globals});
}

//
// Callback for prefUserDialog.xul's onAccept.
// Arguments:
//   - prefs[0] - new username
//   - prefs[1] - new password
//   - prefs[2] - new account name
//   - myGlobals - globals
// Return true if ok to close prefUserDialog, false otherwise.
//
function accountInfoEntered(prefs, myGlobals)
{
    if (usernameIsInUse(prefs[0], true)) {
        return false;
    }
    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    var li = accountListbox.appendItem(prefs[2], prefs[0]);
    var lc = document.createElement('listcell');
    lc.setAttribute("class", "listcell-iconic");
    li.appendChild(lc);
    myGlobals.userManager.createUser(prefs[0], prefs[1], prefs[2]);
    markNewDefaultUser(myGlobals.userManager.getDefaultUser().getUsername(), '');
    return true;
}

function deleteAccount()
{
    var accountListbox = document.getElementById("delicious-prefs-accounts-list");
    if (!accountListbox.selectedItem) {
        return;
    }
    globals.userManager.deleteUser(accountListbox.selectedItem.value);
    markNewDefaultUser(globals.userManager.getDefaultUser().getUsername(), '');
    accountListbox.removeChild(accountListbox.selectedItem);
}
